fn main() {
    let longest = find_longest(1_000_000);
    println!("{longest}");
}

fn collatz_seq(start: usize) -> Vec<usize> {
    let mut sequence = vec![start];
    let mut curr = start;
    loop {
        if curr == 1 {
            break;
        }
        if curr % 2 == 0{
            curr /= 2;
        } else {
            curr = 3 * curr + 1;
        }
        sequence.push(curr);
    }
    sequence
}

fn find_longest(max_start: usize) -> usize {
    let mut biggest = (0, 0);

    for i in 1..max_start {
        let seq = collatz_seq(i);
        if seq.len() > biggest.1 {
            biggest = (i, seq.len());
        }
    }

    biggest.0
}

