use project_euler::number::Number;

fn main() {
    let factorials_sum = digit_factorials();
    println!("{factorials_sum}");
}

fn factorial(num: isize) -> isize {
    let mut fact = 1;
    for n in 1..=num {
        fact = fact * n;
    }
    fact
}

fn digit_factorials() -> isize {
    let mut factorials = vec![];
    let mut max = factorial(9);
    let mut idx = 1;
    loop {
        let attempt = max * idx;
        if Number::from(attempt).digits.len() < idx as usize {
            max = (idx - 1) * max;
            break;
        }
        idx += 1;
    }
    for n in 3..=max {
        let digits_fact_sum = Number::from(n).digits.iter().map(|&digit| factorial(digit)).sum();
        if n == digits_fact_sum {
            factorials.push(n);
        }
    }
    factorials.iter().sum()
}