fn main() {
    let result = nth_prime(10001);
    println!("Result: {}", result.unwrap());
}

fn nth_prime(nth: i64) -> Option<i64> {
    let mut primes: Vec<i64> = vec![2];

    let mut i = 3;

    while primes.len() < nth as usize {
        let mut is_prime = true;
        for prime in &primes {
            if i % prime == 0 {
                is_prime = false;
                break;
            }
        }
        if is_prime {
            primes.push(i);
        }
        i += 1;
    }

    return primes.pop();
}

#[cfg(test)]
mod tests {
    use crate::nth_prime;

    #[test]
    fn it_works() {
        let result = nth_prime(6);
        assert_eq!(result.unwrap(), 13);
    }
}
